version: '3'

services:
  # Frontend
  web:
    image: jitsi/web:stable-5963
    restart: ${RESTART_POLICY}
    ports:
        - '${HTTP_PORT}:80'
        - '${HTTPS_PORT}:443'
    volumes:
        - ${CONFIG}/web:/config:Z
        - ${CONFIG}/transcripts:/usr/share/jitsi-meet/transcripts:Z
    environment:
        - ENABLE_COLIBRI_WEBSOCKET
        - ENABLE_FLOC
        - ENABLE_LETSENCRYPT
        - ENABLE_HTTP_REDIRECT
        - ENABLE_HSTS
        - ENABLE_XMPP_WEBSOCKET
        - DISABLE_HTTPS
        - DISABLE_DEEP_LINKING
        - LETSENCRYPT_DOMAIN
        - LETSENCRYPT_EMAIL
        - LETSENCRYPT_USE_STAGING
        - PUBLIC_URL
        - TZ
        - AMPLITUDE_ID
        - ANALYTICS_SCRIPT_URLS
        - ANALYTICS_WHITELISTED_EVENTS
        - CALLSTATS_CUSTOM_SCRIPT_URL
        - CALLSTATS_ID
        - CALLSTATS_SECRET
        - CHROME_EXTENSION_BANNER_JSON
        - CONFCODE_URL
        - CONFIG_EXTERNAL_CONNECT
        - DEFAULT_LANGUAGE
        - DEPLOYMENTINFO_ENVIRONMENT
        - DEPLOYMENTINFO_ENVIRONMENT_TYPE
        - DEPLOYMENTINFO_REGION
        - DEPLOYMENTINFO_SHARD
        - DEPLOYMENTINFO_USERREGION
        - DIALIN_NUMBERS_URL
        - DIALOUT_AUTH_URL
        - DIALOUT_CODES_URL
        - DROPBOX_APPKEY
        - DROPBOX_REDIRECT_URI
        - DYNAMIC_BRANDING_URL
        - ENABLE_AUDIO_PROCESSING
        - ENABLE_AUTH
        - ENABLE_CALENDAR
        - ENABLE_FILE_RECORDING_SERVICE
        - ENABLE_FILE_RECORDING_SERVICE_SHARING
        - ENABLE_GUESTS
        - ENABLE_IPV6
        - ENABLE_LIPSYNC
        - ENABLE_NO_AUDIO_DETECTION
        - ENABLE_P2P
        - ENABLE_PREJOIN_PAGE
        - ENABLE_WELCOME_PAGE
        - ENABLE_CLOSE_PAGE
        - ENABLE_RECORDING
        - ENABLE_REMB
        - ENABLE_REQUIRE_DISPLAY_NAME
        - ENABLE_SIMULCAST
        - ENABLE_STATS_ID
        - ENABLE_STEREO
        - ENABLE_SUBDOMAINS
        - ENABLE_TALK_WHILE_MUTED
        - ENABLE_TCC
        - ENABLE_TRANSCRIPTIONS
        - ETHERPAD_PUBLIC_URL
        - ETHERPAD_URL_BASE
        - GOOGLE_ANALYTICS_ID
        - GOOGLE_API_APP_CLIENT_ID
        - INVITE_SERVICE_URL
        - JICOFO_AUTH_USER
        - MATOMO_ENDPOINT
        - MATOMO_SITE_ID
        - MICROSOFT_API_APP_CLIENT_ID
        - NGINX_RESOLVER
        - NGINX_WORKER_PROCESSES
        - NGINX_WORKER_CONNECTIONS
        - PEOPLE_SEARCH_URL
        - RESOLUTION
        - RESOLUTION_MIN
        - RESOLUTION_WIDTH
        - RESOLUTION_WIDTH_MIN
        - START_AUDIO_ONLY
        - START_AUDIO_MUTED
        - START_WITH_AUDIO_MUTED
        - START_SILENT
        - DISABLE_AUDIO_LEVELS
        - ENABLE_NOISY_MIC_DETECTION
        - START_BITRATE
        - DESKTOP_SHARING_FRAMERATE_MIN
        - DESKTOP_SHARING_FRAMERATE_MAX
        - START_VIDEO_MUTED
        - START_WITH_VIDEO_MUTED
        - TESTING_CAP_SCREENSHARE_BITRATE
        - TESTING_OCTO_PROBABILITY
        - XMPP_AUTH_DOMAIN
        - XMPP_BOSH_URL_BASE
        - XMPP_DOMAIN
        - XMPP_GUEST_DOMAIN
        - XMPP_MUC_DOMAIN
        - XMPP_RECORDER_DOMAIN
        - TOKEN_AUTH_URL
    networks:
        meet.jitsi:

  # XMPP server
  prosody:
    image: jitsi/prosody:stable-5963
    restart: ${RESTART_POLICY}
    expose:
        - '5222'
        - '5347'
        - '5280'
    volumes:
        - ${CONFIG}/prosody/config:/config:Z
        - ${CONFIG}/prosody/prosody-plugins-custom:/prosody-plugins-custom:Z
          # - /var/local/prosody:/usr/lib/prosody/modules/:Z
    environment:
        - AUTH_TYPE
        - ENABLE_AUTH
        - ENABLE_GUESTS
        - ENABLE_LOBBY
        - ENABLE_XMPP_WEBSOCKET
        - GLOBAL_MODULES
        - GLOBAL_CONFIG
        - LDAP_URL
        - LDAP_BASE
        - LDAP_BINDDN
        - LDAP_BINDPW
        - LDAP_FILTER
        - LDAP_AUTH_METHOD
        - LDAP_VERSION
        - LDAP_USE_TLS
        - LDAP_TLS_CIPHERS
        - LDAP_TLS_CHECK_PEER
        - LDAP_TLS_CACERT_FILE
        - LDAP_TLS_CACERT_DIR
        - LDAP_START_TLS
        - XMPP_DOMAIN
        - XMPP_AUTH_DOMAIN
        - XMPP_GUEST_DOMAIN
        - XMPP_MUC_DOMAIN
        - XMPP_INTERNAL_MUC_DOMAIN
        - XMPP_MODULES
        - XMPP_MUC_MODULES
        - XMPP_INTERNAL_MUC_MODULES
        - XMPP_RECORDER_DOMAIN
        - XMPP_CROSS_DOMAIN
        - JICOFO_COMPONENT_SECRET
        - JICOFO_AUTH_USER
        - JICOFO_AUTH_PASSWORD
        - JVB_AUTH_USER
        - JVB_AUTH_PASSWORD
        - JIGASI_XMPP_USER
        - JIGASI_XMPP_PASSWORD
        - JIBRI_XMPP_USER
        - JIBRI_XMPP_PASSWORD
        - JIBRI_RECORDER_USER
        - JIBRI_RECORDER_PASSWORD
        - JWT_APP_ID
        - JWT_APP_SECRET
        - JWT_ACCEPTED_ISSUERS
        - JWT_ACCEPTED_AUDIENCES
        - JWT_ASAP_KEYSERVER
        - JWT_ALLOW_EMPTY
        - JWT_AUTH_TYPE
        - JWT_TOKEN_AUTH_MODULE
        - LOG_LEVEL
        - PUBLIC_URL
        - TZ
    networks:
        meet.jitsi:
            aliases:
                - ${XMPP_SERVER}

  # Focus component
  jicofo:
    image: jitsi/jicofo:stable-5963
    restart: ${RESTART_POLICY}
    volumes:
        - ${CONFIG}/jicofo:/config:Z
    environment:
        - AUTH_TYPE
        - BRIDGE_AVG_PARTICIPANT_STRESS
        - BRIDGE_STRESS_THRESHOLD
        - ENABLE_AUTH
        - ENABLE_AUTO_OWNER
        - ENABLE_CODEC_VP8
        - ENABLE_CODEC_VP9
        - ENABLE_CODEC_H264
        - ENABLE_OCTO
        - ENABLE_RECORDING
        - ENABLE_SCTP
        - JICOFO_AUTH_USER
        - JICOFO_AUTH_PASSWORD
        - JICOFO_ENABLE_BRIDGE_HEALTH_CHECKS
        - JICOFO_CONF_INITIAL_PARTICIPANT_WAIT_TIMEOUT
        - JICOFO_CONF_SINGLE_PARTICIPANT_TIMEOUT
        - JICOFO_ENABLE_HEALTH_CHECKS
        - JICOFO_SHORT_ID
        - JICOFO_RESERVATION_ENABLED 
        - JICOFO_RESERVATION_REST_BASE_URL 
        - JIBRI_BREWERY_MUC
        - JIBRI_REQUEST_RETRIES
        - JIBRI_PENDING_TIMEOUT
        - JIGASI_BREWERY_MUC
        - JIGASI_SIP_URI
        - JVB_BREWERY_MUC
        - MAX_BRIDGE_PARTICIPANTS
        - OCTO_BRIDGE_SELECTION_STRATEGY
        - TZ
        - XMPP_DOMAIN
        - XMPP_AUTH_DOMAIN
        - XMPP_INTERNAL_MUC_DOMAIN
        - XMPP_MUC_DOMAIN
        - XMPP_SERVER
    depends_on:
        - prosody
    networks:
        meet.jitsi:

  # Video bridge
  jvb:
    image: jitsi/jvb:stable-5963
    restart: ${RESTART_POLICY}
    ports:
        - '${JVB_PORT}:${JVB_PORT}/udp'
        - '${JVB_TCP_PORT}:${JVB_TCP_PORT}'
    volumes:
        - ${CONFIG}/jvb:/config:Z
    environment:
        - ENABLE_COLIBRI_WEBSOCKET
        - ENABLE_OCTO
        - DOCKER_HOST_ADDRESS
        - XMPP_AUTH_DOMAIN
        - XMPP_INTERNAL_MUC_DOMAIN
        - XMPP_SERVER
        - JVB_AUTH_USER
        - JVB_AUTH_PASSWORD
        - JVB_BREWERY_MUC
        - JVB_PORT
        - JVB_TCP_HARVESTER_DISABLED
        - JVB_TCP_PORT
        - JVB_TCP_MAPPED_PORT
        - JVB_STUN_SERVERS
        - JVB_ENABLE_APIS
        - JVB_WS_DOMAIN
        - JVB_WS_SERVER_ID
        - PUBLIC_URL
        - JVB_OCTO_BIND_ADDRESS
        - JVB_OCTO_PUBLIC_ADDRESS
        - JVB_OCTO_BIND_PORT
        - JVB_OCTO_REGION
        - TZ
    depends_on:
        - prosody
    networks:
        meet.jitsi:
            aliases:
                - jvb.meet.jitsi

  jibri:
    image: jitsi/jibri:stable-5963
    restart: ${RESTART_POLICY}
    volumes:
        - ${CONFIG}/jibri:/config:Z
        - /dev/shm:/dev/shm
    cap_add:
        - SYS_ADMIN
        - NET_BIND_SERVICE
    devices:
        - /dev/snd:/dev/snd
    environment:
        - PUBLIC_URL
        - XMPP_AUTH_DOMAIN
        - XMPP_INTERNAL_MUC_DOMAIN
        - XMPP_RECORDER_DOMAIN
        - XMPP_SERVER
        - XMPP_DOMAIN
        - JIBRI_XMPP_USER
        - JIBRI_XMPP_PASSWORD
        - JIBRI_BREWERY_MUC
        - JIBRI_RECORDER_USER
        - JIBRI_RECORDER_PASSWORD
        - JIBRI_RECORDING_DIR
        - JIBRI_FINALIZE_RECORDING_SCRIPT_PATH
        - JIBRI_STRIP_DOMAIN_JID
        - JIBRI_LOGS_DIR
        - DISPLAY=:0
        - TZ
    depends_on:
        - jicofo
    networks:
        meet.jitsi:

# Custom network so all services can communicate using a FQDN
networks:
    meet.jitsi: